/*
 * Copyright © Original Authors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional copyright and licensing notices may apply for content that was
 * included from other projects. For more information, see ATTRIBUTION.md.
 */

package grondag.xm;

import static grondag.xm.XmConfig.DEFAULTS;
import static grondag.xm.XmConfig.debugCollisionBoxes;

import java.util.Arrays;
import java.util.stream.Collectors;

import me.shedaniel.clothconfig2.api.ConfigBuilder;
import me.shedaniel.clothconfig2.api.ConfigCategory;
import me.shedaniel.clothconfig2.api.ConfigEntryBuilder;
import net.minecraft.class_1074;
import net.minecraft.class_2561;
import net.minecraft.class_2585;
import net.minecraft.class_2588;
import net.minecraft.class_437;

public class ConfigScreen {
	private static ConfigEntryBuilder ENTRY_BUILDER = ConfigEntryBuilder.create();

	static class_2561[] parse(String key) {
		return Arrays.stream(class_1074.method_4662("config.xblocks.help.force_key").split(";")).map(s -> new class_2585(s)).collect(Collectors.toList()).toArray(new class_2561[0]);
	}

	static class_437 getScreen(class_437 parent) {
		final ConfigBuilder builder = ConfigBuilder.create().setParentScreen(parent).setTitle(new class_2588("config.xm.title")).setSavingRunnable(ConfigScreen::saveUserInput);

		// DEBUG
		final ConfigCategory blocks = builder.getOrCreateCategory(new class_2588("config.xm.category.debug"));

		blocks.addEntry(ENTRY_BUILDER.startBooleanToggle(new class_2588("config.xm.value.debug_collision_boxes"), debugCollisionBoxes)
				.setDefaultValue(DEFAULTS.debugCollisionBoxes)
				.setSaveConsumer(b -> debugCollisionBoxes = b)
				.setTooltip(parse("config.xm.help.debug_collision_boxes"))
				.build());

		return builder.build();
	}

	private static void saveUserInput() {
		XmConfig.saveConfig();
	}
}
