/*
 * Copyright © Original Authors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional copyright and licensing notices may apply for content that was
 * included from other projects. For more information, see ATTRIBUTION.md.
 */

package grondag.xm.api.block;

import org.jetbrains.annotations.ApiStatus.Experimental;
import grondag.fermion.orientation.api.CubeCorner;
import grondag.fermion.orientation.api.CubeEdge;
import grondag.fermion.orientation.api.CubeRotation;
import grondag.fermion.orientation.api.HorizontalEdge;
import grondag.fermion.orientation.api.HorizontalFace;
import grondag.xm.api.modelstate.primitive.SimplePrimitiveStateMutator;
import net.minecraft.class_2350;
import net.minecraft.class_2741;
import net.minecraft.class_2753;
import net.minecraft.class_2754;

@Experimental
public class XmProperties {
	public static final class_2754<class_2350.class_2351> AXIS = class_2741.field_12496;
	public static final class_2754<HorizontalFace> HORIZONTAL_FACE = class_2754.method_11850("xm_horiz_face", HorizontalFace.class);
	public static final class_2754<HorizontalEdge> HORIZONTAL_EDGE = class_2754.method_11850("xm_horiz_edge", HorizontalEdge.class);
	public static final class_2753 FACE = class_2741.field_12525;
	public static final class_2754<CubeCorner> CORNER = class_2754.method_11850("xm_corner", CubeCorner.class);
	public static final class_2754<CubeEdge> EDGE = class_2754.method_11850("xm_edge", CubeEdge.class);
	public static final class_2754<CubeRotation> ROTATION = class_2754.method_11850("xm_rotation", CubeRotation.class);

	public static SimplePrimitiveStateMutator AXIS_MODIFIER = (modelState, blockState) -> {
		final class_2350.class_2351 axis = blockState.method_11654(AXIS);
		modelState.orientationIndex(axis.ordinal());
		return modelState;
	};

	public static SimplePrimitiveStateMutator HORIZONTAL_FACE_MODIFIER = (modelState, blockState) -> {
		final HorizontalFace face = blockState.method_11654(HORIZONTAL_FACE);
		modelState.orientationIndex(face.ordinal());
		return modelState;
	};

	public static SimplePrimitiveStateMutator HORIZONTAL_EDGE_MODIFIER = (modelState, blockState) -> {
		final HorizontalEdge edge = blockState.method_11654(HORIZONTAL_EDGE);
		modelState.orientationIndex(edge.ordinal());
		return modelState;
	};

	public static SimplePrimitiveStateMutator FACE_MODIFIER = (modelState, blockState) -> {
		final class_2350 face = blockState.method_11654(FACE);
		modelState.orientationIndex(face.ordinal());
		return modelState;
	};

	public static SimplePrimitiveStateMutator CORNER_MODIFIER = (modelState, blockState) -> {
		final CubeCorner corner = blockState.method_11654(CORNER);
		modelState.orientationIndex(corner.ordinal());
		return modelState;
	};

	public static SimplePrimitiveStateMutator EDGE_MODIFIER = (modelState, blockState) -> {
		final CubeEdge edge = blockState.method_11654(EDGE);
		modelState.orientationIndex(edge.ordinal());
		return modelState;
	};

	public static SimplePrimitiveStateMutator ROTATION_MODIFIER = (modelState, blockState) -> {
		final CubeRotation edge = blockState.method_11654(ROTATION);
		modelState.orientationIndex(edge.ordinal());
		return modelState;
	};
}
