/*
 * Copyright © Original Authors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional copyright and licensing notices may apply for content that was
 * included from other projects. For more information, see ATTRIBUTION.md.
 */

package grondag.xm.api.connect.species;

import net.minecraft.class_1922;
import net.minecraft.class_2338;
import net.minecraft.class_2680;

@FunctionalInterface
public interface SpeciesFunction {
	int NO_SPECIES = -1;

	/**
	 *
	 * @param world
	 * @param blockState
	 * @param pos
	 * @return Numeric species value >=0 if block has one, {@link #NO_SPECIES} otherwise.
	 */
	int species(class_1922 world, class_2680 blockState, class_2338 pos);

	default int species(class_1922 world, class_2338 pos) {
		return species(world, world.method_8320(pos), pos);
	}
}
