/*
 * Copyright © Original Authors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional copyright and licensing notices may apply for content that was
 * included from other projects. For more information, see ATTRIBUTION.md.
 */

package grondag.xm.api.connect.world;

import org.jetbrains.annotations.Nullable;
import grondag.xm.api.modelstate.ModelState;
import net.minecraft.class_1922;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2586;
import net.minecraft.class_2680;

public interface BlockTestContext<T extends ModelState> {
	class_1922 world();

	class_2338 fromPos();

	class_2680 fromBlockState();

	@Nullable
	class_2586 fromBlockEntity();

	@Nullable
	T fromModelState();

	class_2338 toPos();

	class_2680 toBlockState();

	@Nullable
	class_2586 toBlockEntity();

	@Nullable
	T toModelState();

	/**
	 * If this test is for a face adjacent to the "from" block,
	 * the face that describes the relative position of the "to" block.
	 *
	 * @return Face relative to from block, as described above.
	 * Or null if this test is for a corner block.
	 */
	@Nullable
	class_2350 toFace();
}
