/*
 * Copyright © Original Authors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional copyright and licensing notices may apply for content that was
 * included from other projects. For more information, see ATTRIBUTION.md.
 */

package grondag.xm.api.item;

import java.util.function.BiFunction;
import java.util.function.Function;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import org.jetbrains.annotations.ApiStatus.Experimental;
import grondag.xm.api.modelstate.MutableModelState;
import grondag.xm.dispatch.XmRegistryImpl;

@Experimental
public class XmItemRegistry {
	private XmItemRegistry() { }

	/**
	 * @deprecated Use version that accepts world for item state
	 */
	@Deprecated
	public static void addItem(class_1792 item, Function<class_1799, MutableModelState> modelFunction) {
		XmRegistryImpl.register(item, (s, w) -> modelFunction.apply(s));
	}

	public static void addItem(class_1792 item, BiFunction<class_1799, class_1937, MutableModelState> modelFunction) {
		XmRegistryImpl.register(item, modelFunction);
	}
}
