/*
 * Copyright © Original Authors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional copyright and licensing notices may apply for content that was
 * included from other projects. For more information, see ATTRIBUTION.md.
 */

package grondag.xm.api.paint;

import org.jetbrains.annotations.ApiStatus.Experimental;
import grondag.xm.Xm;
import grondag.xm.paint.VertexProcessorRegistryImpl;
import net.minecraft.class_2960;

@Experimental
public interface VertexProcessorRegistry {
	/**
	 * Will always be associated with index 0.
	 */
	class_2960 NONE_ID = new class_2960(Xm.MODID, "none");

	VertexProcessorRegistry INSTANCE = VertexProcessorRegistryImpl.INSTANCE;

	VertexProcessor get(class_2960 id);

	VertexProcessor get(int index);

	VertexProcessor add(class_2960 id, VertexProcessor set);

	class_2960 getKey(VertexProcessor value);

	boolean containsKey(class_2960 id);
}
