/*
 * Copyright © Original Authors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional copyright and licensing notices may apply for content that was
 * included from other projects. For more information, see ATTRIBUTION.md.
 */

package grondag.xm.api.paint;

import org.jetbrains.annotations.ApiStatus.Experimental;
import grondag.xm.api.texture.TextureSet;
import net.minecraft.class_2960;

@Experimental
public interface XmPaintFinder {
	XmPaint find();

	XmPaintFinder clear();

	XmPaintFinder copy(XmPaint paint);

	XmPaintFinder textureDepth(int depth);

	XmPaintFinder textureColor(int textureIndex, int colorARBG);

	XmPaintFinder texture(int textureIndex, TextureSet sprite);

	@Deprecated
	XmPaintFinder blendMode(int textureIndex, PaintBlendMode blendMode);

	XmPaintFinder blendMode(PaintBlendMode blendMode);

	XmPaintFinder disableColorIndex(int textureIndex, boolean disable);

	XmPaintFinder disableDiffuse(int textureIndex, boolean disable);

	XmPaintFinder disableAo(int textureIndex, boolean disable);

	XmPaintFinder emissive(int textureIndex, boolean isEmissive);

	XmPaintFinder shader(class_2960 shader);

	XmPaintFinder condition(class_2960 condition);

	XmPaintFinder vertexProcessor(int textureIndex, VertexProcessor vp);
}
