/*
 * Copyright © Original Authors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional copyright and licensing notices may apply for content that was
 * included from other projects. For more information, see ATTRIBUTION.md.
 */

package grondag.xm.dispatch;

import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet;
import net.minecraft.class_1091;
import net.minecraft.class_1100;
import net.minecraft.class_2378;
import org.jetbrains.annotations.ApiStatus.Internal;
import org.jetbrains.annotations.Nullable;
import io.vram.frex.api.model.provider.ModelProvider;
import io.vram.frex.api.model.provider.SubModelLoader;

import grondag.xm.api.block.XmBlockState;

@Internal
public class XmVariantProvider implements ModelProvider<class_1091> {
	private final ObjectOpenHashSet<String> targets = new ObjectOpenHashSet<>();

	public XmVariantProvider() {
		targets.clear();

		class_2378.field_11146.forEach(b -> {
			if (XmBlockState.get(b) != null) {
				targets.add(class_2378.field_11146.method_10221(b).toString());
			}
		});

		class_2378.field_11142.forEach(i -> {
			if (((XmItemAccess) i).xm_modelStateFunc() != null) {
				targets.add(class_2378.field_11142.method_10221(i).toString());
			}
		});
	}

	@Override
	public @Nullable class_1100 loadModel(class_1091 path, SubModelLoader subModelLoader) {
		return targets.contains(path.method_12836() + ":" + path.method_12832()) ? XmModelProxy.INSTANCE : null;
	}
}
