/*
 * Copyright © Original Authors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional copyright and licensing notices may apply for content that was
 * included from other projects. For more information, see ATTRIBUTION.md.
 */

package grondag.xm.mesh.vertex;

import org.jetbrains.annotations.ApiStatus.Internal;
import grondag.xm.api.mesh.polygon.Vec3f;
import net.minecraft.class_2350;
import net.minecraft.class_2382;

@Internal
public class Vec3fFactory {
	private Vec3fFactory() { }

	private static final Vec3f[] FACES = new Vec3f[6];

	static {
		FACES[class_2350.field_11036.ordinal()] = create(class_2350.field_11036.method_10163());
		FACES[class_2350.field_11033.ordinal()] = create(class_2350.field_11033.method_10163());
		FACES[class_2350.field_11034.ordinal()] = create(class_2350.field_11034.method_10163());
		FACES[class_2350.field_11039.ordinal()] = create(class_2350.field_11039.method_10163());
		FACES[class_2350.field_11043.ordinal()] = create(class_2350.field_11043.method_10163());
		FACES[class_2350.field_11035.ordinal()] = create(class_2350.field_11035.method_10163());
	}

	public static final Vec3f ZERO = Vec3fImpl.ZERO;

	public static Vec3f forFace(class_2350 face) {
		return FACES[face.ordinal()];
	}

	public static Vec3f create(class_2382 vec) {
		return create(vec.method_10263(), vec.method_10264(), vec.method_10260());
	}

	public static Vec3f create(float x, float y, float z) {
		return Vec3fCache.INSTANCE.get(x, y, z);
	}
}
