/*
 * Copyright © Original Authors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additional copyright and licensing notices may apply for content that was
 * included from other projects. For more information, see ATTRIBUTION.md.
 */

package grondag.xm.texture;

import java.util.function.Consumer;
import net.minecraft.class_2348;
import net.minecraft.class_2378;
import net.minecraft.class_2385;
import net.minecraft.class_2960;
import net.minecraft.class_5321;
import com.mojang.serialization.Lifecycle;
import grondag.xm.Xm;
import grondag.xm.api.texture.TextureGroup;
import grondag.xm.api.texture.TextureLayoutMap;
import grondag.xm.api.texture.TextureRenderIntent;
import grondag.xm.api.texture.TextureScale;
import grondag.xm.api.texture.TextureSet;
import grondag.xm.api.texture.TextureSetRegistry;
import grondag.xm.api.texture.TextureTransform;

@SuppressWarnings({ "unchecked", "rawtypes" })
public class TextureSetRegistryImpl implements TextureSetRegistry {
	public static final TextureSetImpl DEFAULT_TEXTURE_SET;

	private static final class_5321 REGISTRY_KEY = class_5321.method_29180(Xm.id("texture_sets"));
	private static final class_2385<TextureSetImpl> REGISTRY;

	public static final TextureSetRegistryImpl INSTANCE = new TextureSetRegistryImpl();

	public static TextureSet noTexture() {
		return INSTANCE.get(0);
	}

	@Override
	public TextureSetImpl get(class_2960 id) {
		return REGISTRY.method_10223(id);
	}

	@Override
	public TextureSetImpl get(int index) {
		return index < 0 ? DEFAULT_TEXTURE_SET : REGISTRY.method_10200(index);
	}

	public int indexOf(TextureSetImpl set) {
		return REGISTRY.method_10206(set);
	}

	@Override
	public void forEach(Consumer<TextureSet> consumer) {
		REGISTRY.forEach(consumer);
	}

	public boolean contains(class_2960 id) {
		return REGISTRY != null && REGISTRY.method_10235().contains(id);
	}

	static {
		REGISTRY = (class_2385<TextureSetImpl>) ((class_2385) class_2378.field_11144).method_10272(REGISTRY_KEY,
				new class_2348(NONE_ID.toString(), REGISTRY_KEY, Lifecycle.stable()), Lifecycle.stable());

		DEFAULT_TEXTURE_SET = (TextureSetImpl) TextureSet.builder().displayNameToken("none").baseTextureName("exotic-matter:block/noise_moderate").versionCount(4)
				.scale(TextureScale.SINGLE).layout(TextureLayoutMap.VERSION_X_8).transform(TextureTransform.ROTATE_RANDOM)
				.renderIntent(TextureRenderIntent.BASE_ONLY).groups(TextureGroup.ALWAYS_HIDDEN).build(TextureSetRegistry.NONE_ID);

		DEFAULT_TEXTURE_SET.use();
	}

	void add(TextureSetImpl set) {
		class_2378.method_10230(REGISTRY, set.id, set);
	}
}
